
	CPU 186
	BITS 16
	
	ORG	0

%ifndef BUILD
%define BUILD '(internally)'
%endif

		dd	0xffffffff
		dw	0x8000
		dw	Strategy
dini		dw	Init_Commands
		db	'$DSPSTUB'

reqhdr		dd	0
org_10		dd	0
org_15		dd	0
dbcs_vect	dd	0
apatop		dd	0xb8000000
current_col	dw	80
current_row	dw	25
default_row	dw	25
apa_bottom	dw	80 * 25 * 2
active_n10	db	0

Strategy:
	mov	word [cs: reqhdr], bx
	mov	word [cs: reqhdr + 2], es
	retf

Commands:
	push	bx
	push	ds
	lds	bx, [cs: reqhdr]
	mov	word [bx + 3], 0x8103
	pop	ds
	pop	bx
	retf


n10_f1d:
	push	ds
	push	ax
	push	word 0
	pop	ds
	xor	ah, ah
	;
	cmp	al, 0
	je	.f1d_0
	cmp	al, 1
	je	.f1d_1
	cmp	al, 2
	je	.f1d_2
.f1d_exit:
	pop	ax
	pop	ds	
	popf
	iret

.f1d_1:
	mov	ax, [cs: default_row]
	jmp	short .f1d_0_wrow
.f1d_0:
	mov	al, byte [0x0484]
	sub	ax, bx
	jbe	.f1d_exit
.f1d_0_wrow:
	mov	byte [0x0484], al
	inc	ax
	mov	[cs: current_row], ax
	jmp	short .f1d_exit

.f1d_2:
	mov	al, byte [0x0484]
	inc	ax
	mov	bx, [cs: default_row]
	sub	bx, ax
	sbb	ax, ax
	not	ax
	and	bx, ax
	jmp	short .f1d_exit

New10:
	pushf
	cmp	ah, 0
	je	n10_f00
;	cmp	ax, 0x4f00
;	je	n10_vbe
	cmp	byte [cs: active_n10], 0
	je	.exit
	
	cmp	ah, 0x1d	; get/set Status Line
	je	n10_f1d
	cmp	ax, 0x1310
	je	n10_f13r
;	cmp	ax, 0x1311
;	je	n10_f13r
	cmp	ax, 0x1320
	je	n10_f13w
;	cmp	ax, 0x1321
;	je	n10_f13w
	cmp	ah, 0xfe
	je	n10_ffe
.exit:
	popf
	jmp	far [cs: org_10]

n10_ffe:
	les	di, [cs:apatop]
	popf
	iret

n10_f00:
	cmp	al, 3
	je	.f00_2
	cmp	al, 0x83
	jne	New10.exit
.f00_2:
	call	far [cs: org_10]
	call	get_current_ssize

n10_chkvm_dosv:
	push	bx
	push	ds
	lds	bx, [cs: dbcs_vect]
	mov	bx, word [bx]
	add	bx, 0xffff
	sbb	bl, bl
	mov	[cs: active_n10], bl
	pop	ds
	pop	bx
	iret

n10_f13r:
	pusha
	push	ds
	push	es
	cld
	mov	di, bp
	call	norm_charcount
	mov	ds, word [cs: apatop + 2]
	mov	si, bx
	rep	movsw
	jmp	short n10_f13_exit

n10_f13w:
	pusha
	push	ds
	push	es
	cld
	push	es	; mov ds, es
	pop	ds
	mov	si, bp
	call	norm_charcount
	mov	es, word [cs: apatop + 2]
	mov	di, bx
	rep	movsw
n10_f13_exit:
	pop	es
	pop	ds
	popa
	popf
	iret

norm_charcount:
	; in
	;  (dl, dh) scrn position
	;   cx      count by char (not by byte)
	; out
	;   bx      scrn address offset
	;   cx      normalized count by char
	;   ax      (broken)
	mov	bx, dx
	mov	al, byte [cs: current_col]
	mul	bh
	add	ax, ax
	jc	.overflow
	xor	bh, bh
	add	bx, bx
	add	bx, ax
	jc	.overflow
	mov	ax, cx
	add	ax, cx
	jc	.overflow
	add	ax, bx
	jc	.overflow
	cmp	ax, [cs: apa_bottom]
	ja	.do_norm
	ret
.do_norm:
	mov	cx, [cs: apa_bottom]
	sub	cx, bx
	ja	.overflow
	shr	cx, 1
	ret
.overflow:
	xor	cx, cx
	ret

get_current_ssize:
	push	ax
	push	dx
	push	ds
	xor	ax, ax
	push	ax
	pop	ds
	mov	al, byte [0x0484]	; 0040:0084 rows (-1)
	cmp	al, 0			; assume 25line if bl==0
	je	.row_line25
	inc	ax
	jmp	short .row_w
.row_line25:
	mov	al, 25
.row_w:
	mov	[cs: current_row], ax
	mov	[cs: default_row], ax
	mov	dx, word [0x044a]	; 0040:004a columns
	mov	[cs: current_col], dx
	add	ax, ax
	mul	dx
	mov	[cs: apa_bottom], ax
	pop	ds
	pop	dx
	pop	ax
	ret


New15:
	cmp	ax, 0x4900
	je	n15_dosv
	jmp	far [cs: org_15]
n15_dosv:
	mov	ah, 0
	mov	bl, 0
	clc
	retf 2


Dev_Bottom:
;----------------------------------------------------------------------------


Init_Commands:
	push	ds
	push	es
	pusha
	
	mov	ax, 0x6300
	int	0x21
	mov	[cs: dbcs_vect], si
	mov	[cs: dbcs_vect + 2], ds
	
	push	cs
	pop	ds
	
	mov	dx, msgOpening
	call	pMsg
	
	mov	ax, 0x3510
	int	0x21
	mov	[org_10], bx
	mov	[org_10 + 2], es
	mov	ax, 0x3515
	int	0x21
	mov	[org_15], bx
	mov	[org_15 + 2], es
	
	mov	bx, -1
	mov	ax, 0x4900
	int	0x15
	and	bl, 0xfe
	jz	.exit_err
	
.exit_noerr:
	call	get_current_ssize
	mov	dx, New10
	mov	ax, 0x2510
	int	0x21
	mov	dx, New15
	mov	ax, 0x2515
	int	0x21
	mov	[active_n10], byte 1
	les	bx, [reqhdr]
	mov	word [es: bx + 0x0e], Dev_Bottom
	mov	word [es: bx + 0x10], cs
	mov	word [es: bx + 3], 0x0100
	mov	word [dini], Commands
	
	jmp	short .exit
.exit_err:
	mov	dx, msgErr
	call	pMsg
	les	bx, [reqhdr]
	mov	word [es: bx + 0x0e], 0
	mov	word [es: bx + 0x10], cs
	mov	word [es: bx + 3], 0x8103
.exit:
	popa
	pop	es
	pop	ds
	retf

pMsg:
	push	ax
	mov	ah, 9
	int	0x21
	pop	ax
	ret

msgOpening	db	'dspdummy.sys build ', BUILD
		db	' by sava/LP-Project.'
		db	13, 10, '$'
msgErr		db	'err: DOS/V display subsystem installed.', 13, 10, '$'

